/* GCC */
#include <math.h>
#include <vector>
#include <string>
#include <iostream>
#include <algorithm>

#define pb push_back
#define mp make_pair
#define Ri(a) scanf("%d", &(a))
#define Ri2(a, b) scanf("%d%d", &(a), &(b))
#define Wi(a) printf("%d ", (a))
#define Wi2(a, b) printf("%d %d ", (a), (b))
#define Wie(a) printf("%d\n", (a))
#define Wie2(a, b) printf("%d %d\n", (a), (b))
#define FOR(i,a,b) for( int i = (a), _n_ = (b); i <= _n_; i++ )
#define FORD(i,a,b) for( int i = (a), _n_ = (b); i >= _n_; i-- )
#define forn(i,n) FOR(i,0,(n) - 1)

using namespace std;

int N, n = 0, m = 0;

int pow( int a, int n, int mod ) {
    int ans = 1;
    while( n ) {
           if( n & 1 ) ans *= a, ans %= mod;
           a *= a;
           a %= mod;
           n >>= 1; 
    }
    return ans;
}

const int deb = 0;

int fact( int n, int mod ) {
    int f[200];
    f[0] = f[1] = 1;
    //cout << "mod = " << mod << endl << "------------" << endl;
    FOR( i, 2, mod - 1 ) {
         int t = i;
         while( ( t & 1 ) == 0 ) t >>= 1;
         while( t % 5 == 0 ) t /= 5;
         f[i] = f[i - 1] * t;
         f[i] %= mod;
         if( i < deb ) cout << f[i] << endl;
    }
    //cout << "-------------" << endl;
    int ans = 1;
    while( n ) {
           ans *= pow( f[mod - 1], n / mod, mod );
           ans %= mod;
           ans *= f[n % mod];
           ans %= mod;
           n /= mod;
    }
    return ans;
}

int fact2( int n, int mod ) {
    int ans = 1;
    //cout << "mod = " << mod << endl << "------------" << endl;
    FOR( i, 1, n ) {
         int t = i;
         while( ( t & 1 ) == 0 ) t >>= 1;
         while( t % 5 == 0 ) t /= 5;
         ans *= t;
         ans %= mod;    
         /*if( i < deb )cout << ans << endl;*/
    }
    //cout << "-------------" << endl;
    return ans;
}

int main() {
    freopen("factrl.in", "r", stdin);
    freopen("factrl.out", "w", stdout);
    
    Ri( N );
    int x = N;
    while( x ) n += ( x >> 1 ), x >>=1;
    x = N;
    while( x ) m += x / 5, x /= 5;
    //cout << n << " " << m << endl;
    
    int _8 = fact2( N, 8 ), _125 = fact2( N, 125 ), N0;
    //cout << _8 << " " << _125 << endl;
    //cout << fact2( N, 8 ) << " " << fact2( N, 125 ) << endl; 
    for( N0 = 0; ; N0++ ) {
         if( N0 % 8 == _8 && N0 % 125 == _125 ) break;
    }
    //cout << N0 << endl;
    printf("%.3d\n", (N0 * pow( 2, n - m, 1000 )) % 1000 );
    //system("pause");
}
