/* GCC */

#include <fstream>
#include <sstream>
#include <algorithm>

using namespace std;

struct Player
{
       long Index, Age, Level;
       Player() {}
       Player(long index, long age, long level) : Index(index), Age(age), Level(level) {}
};

Player Players_unsorted[200000];
Player Players[200000];
long pN = 0; //players
long N;

inline bool SORT(Player p1, Player p2)
{
       if(p1.Level == p2.Level)
            return p1.Age < p2.Age;
       else
            return p1.Level < p2.Level;
}

long Solve(long index)
{
     //long i = 0;
     //for(; i < pN; i++)
     //{
     //        if(Players[i].Index == index)
     //             break;
     //}
     
     long begin = 0, end = pN, mid;
     while(begin != end - 1)
     {
          mid = (begin+end)/2;
          
          if(Players[mid].Level == Players_unsorted[index].Level)
          {
              if(Players[mid].Age < Players_unsorted[index].Age)
                  begin = mid;
              else
                  end = mid;                    
          }
          else
          {
              if(Players[mid].Level < Players_unsorted[index].Level)
                  begin = mid;
              else
                  end = mid;   
          }
               
     }
     
     for(long i = begin; i < pN ; i++)
          if(Players[i].Level > Players_unsorted[index].Level &&
             Players[i].Age > Players_unsorted[index].Age)
               return Players[i].Index + 1;
               
     return 0;
}

int main()
{
    stringstream ss;
    
    ifstream fin("cclub.in");
    ss<<fin.rdbuf();
    fin.close();
    
    ss>>N;
    
    ostringstream oss;
    
    char tmp; long tmp1, tmp2; bool flag = false;
    for(int i = 0; i < N; i++)
    {
            ss>>tmp;
            if(tmp == 'P')
            {
                   ss>>tmp1>>tmp2;
                   Players[pN] = Player(pN, tmp1, tmp2);
                   Players_unsorted[pN] = Players[pN];
                   pN++;
                   flag = false;
            }
            else
            {
                   ss>>tmp1;
                   
                   if(!flag)
                   {
                           sort(Players, Players + pN, SORT);
                           flag = true;        
                   }
                       
                   oss<<Solve(tmp1-1)<<endl;
            }
    }
    
    ofstream fout("cclub.out");
    fout<<oss.str();
    fout.close();
    
    return 0;
}
